
;$(function(){
	// "PRIVATE" (INTERNAL) FIELDS
	var inputEventSupport = ('ongesturestart' in window) ? 'GESTURE' : ('ontouchstart' in window) ? "TOUCH" : 'MOUSE';
	var inputEventType = inputEventSupport != 'MOUSE' ? {type:'touch',start:'touchstart',end:'touchend'}:{type:'mouse',start:'mousedown',end:'mouseup'}; 
	var useAnimationsIn = 'MSIE|Firefox|Chrome';
	var isiOS = isInUserAgent('iPad|iPhone|iPod');
	var isiOSStandalone = isiOS && window.navigator.standalone;
	var hideShare = isiOSStandalone;
	var isLoading = false;
	var onSplash = true;
	var fadeDuration = 500; 
	var iniDelay = 500;
	var startupDelay = 1000;
	var startupArgs = {mag:0, pag:0};
	var currentPage = -1;
	var init = {};
	var data = {};
	var index;
	var items;
	var thumbnails;
	var viewport;
	var mediaPlayer;
	var forceNewWindowChar = '*'
	var forceEmailClientChar = '*'
	
	// JQUERY WRAPPER ELEMENTS 
	var $Document = $(document);
	var $Window = $(window);
	var $AppContainer = $('#container');
	var $Splash = $('#splash', $AppContainer);
	var $Header = $('#header', $AppContainer);
	var $HeaderTitle = $('#header_title', $Header);
	var $HeaderLoader = $('#header_loader', $Header);
	var $Main = $('#main', $AppContainer);
	var $MainContent = $('#main_content', $Main);
	var $MainPageError = $('#main_page_error', $Main);
	var $MainPrevious = $('#main_previous', $Main);
	var $MainNext = $('#main_next', $Main);
	var $Footer = $('#footer', $AppContainer);
	var $Share = $('#share', $AppContainer);
	var $Block = $('#block', $AppContainer);
	var $Index = $('#index', $AppContainer);
	var $IndexContent = $('#index_content', $Index);
	var $Items = $('#items', $AppContainer);
	var $ItemsContent = $('#items_content', $Items);
	var $Thumbnails = $('#thumbnails', $AppContainer);
	var $ThumbnailsContent = $('#thumbnails_content', $Thumbnails);
	var $Viewer = $('#viewer', $AppContainer);
	var $ViewerHeaderTitle = $('#viewer_header_title', $Viewer);
	var $ViewerContent = $('#viewer_content', $Viewer);
	var $ViewerLoader = $('#viewer_loader', $Viewer);
	var $Email = $('#email', $AppContainer);
	var $EmailContentContainer = $('#email_content_container', $Email);
	var $LastIndex;
	var $Touch;
	var $OpenFileDummy = $('#open_file_dummy', $AppContainer);
	
	// JQUERY TRANSITIONS (ANIMATIONS) ON/OFF
	$.fx.off = !isInUserAgent(useAnimationsIn);
	
	// INSTALL JQUERY MOUSE WHEEL EVENT
	installMouseWheelEvent();
	
	// CANCEL DOCUMENT TOUCH EVENT
	$Document.on('touchmove', false);
	
	// ATTACH EVENTS TO FUNCTIONS
	$Window.on('resize', updateStage);
	$Window.on('hashchange', hashChange);
	$Window.on('load',function(){setTimeout(ini,iniDelay)});
		
	// KEYBOARD INPUT
	var keyInputEnabled = true;
	var isKeyDown = false;
	$Document.on('keydown',function(event){
		if(isKeyDown){return}
		var key = event.which;
		if(!keyInputEnabled && !(key === 27)){return}
		isKeyDown = true;
		switch(key){
			// PREVIOUS PAGE
			case 37: // ARROW LEFT
			case 33: // PAGE UP
				_gaq.push(['_trackEvent', 'Keyboard', 'Previous page']);
				pageStep(false);
				break;
			// NEXT PAGE
			case 39: // ARROW RIGHT
			case 34: // PAGE DOWN
				_gaq.push(['_trackEvent', 'Keyboard', 'Next page']);
				pageStep(true);
				break;
			// SCROLL UP
			case 38: // ARROW UP
				_gaq.push(['_trackEvent', 'Keyboard', 'Scroll up']);
				viewport.scroll(true);
				break;
			// SCROLL DOWN
			case 40: // ARROW DOWN
				_gaq.push(['_trackEvent', 'Keyboard', 'Scroll down']);
				viewport.scroll(false);
				break;
			// FIRST PAGE
			case 36: // HOME
				_gaq.push(['_trackEvent', 'Keyboard', 'First page']);
				setPage(0);
				break;
			// LAST PAGE
			case 35: // END
				_gaq.push(['_trackEvent', 'Keyboard', 'Last page']);
				setPage(data.pagesCnt - 1);
				break;
			// FIT WIDTH
			case 49: // NUMBER 1
				_gaq.push(['_trackEvent', 'Keyboard', 'Fit width']);
				viewport.scale('width');
				break;
			// FIT ALL
			case 50: // NUMBER 2
				_gaq.push(['_trackEvent', 'Keyboard', 'Fit all']);
				viewport.scale('all');
				break;
			// ZOOM IN
			case 51: // NUMBER 3
				_gaq.push(['_trackEvent', 'Keyboard', 'Zoom in']);
				viewport.scale('in');
				break;
			// ZOOM OUT
			case 52: // NUMBER 4
				_gaq.push(['_trackEvent', 'Keyboard', 'Zoom out']);
				viewport.scale('out');
				break;
			// CLOSE
			case 27: // ESC
			case 8: // BACKSPACE
				_gaq.push(['_trackEvent', 'Keyboard', 'Close']);
				if($Viewer.is(':visible')){showViewer(false);}
				if(typeof $LastIndex !== 'undefined' && $LastIndex.is(':visible')){showIndex(false);}
				if($Share.is(':visible')){showShare();}
				if($Email.is(':visible')){showEmail(false);}
				break;
		}
	});
	
	$Document.on('keyup',function(event){
		isKeyDown = false;
	})
	
	// TOUCH VISUAL FEEDBACK
	if(inputEventType.type == 'touch'){
		$Touch = $('<div id="touch"></div>');
		$AppContainer.append($Touch);
		$Document.on('touchstart', function(event){
			event.originalEvent.touches.length == 1 ? showTouch(true, event.originalEvent.changedTouches[0].pageX, event.originalEvent.changedTouches[0].pageY) : showTouch(false);
		});
		$Document.on('touchmove', function(event){
			if(event.originalEvent.touches.length != 1){return;}
			showTouch(true, event.originalEvent.changedTouches[0].pageX, event.originalEvent.changedTouches[0].pageY);
		});
		$Document.on('touchend', function(event){
			showTouch(false);
		});
	}
	
	// SHOW SPLASH AND LOAD INI FILE
	function ini(){
		$Splash.fadeIn(fadeDuration, function(){
			loadXML("dat/xml/rite.xml", parseXMLIni);
		});
	}
	
	// PARSE INI XML FILE
	function parseXMLIni(xml){
		var vRootNode = $(xml).children("APLICACION");
		// CONFIGURATION
		var vConfigNode = vRootNode.find("CONFIGURACION");
		init.config = {
			webAppAbsoluteURL : vConfigNode.attr("APLICACION_WEB_URL_ABSOLUTO"),
			thumbnailsSuffix : vConfigNode.attr("MINIATURAS_SUFIJO_Y_EXTENSION"),
			emailSendingServer : vConfigNode.attr("CORREO_ELECTRONICO_DE_SERVIDOR_DE_ENVIO"),
			hideShareMenu : vConfigNode.attr("OCULTAR_MENU_COMPARTIR_EN_USERAGENTS_CON"),
			showIndex : vConfigNode.attr("MOSTRAR_MENU_INDICE_GENERAL")
		};		
		// LABELS
		var vLabelsNode = vRootNode.find("ETIQUETAS");
		init.labels = {
			indexBtn : vLabelsNode.attr("BOTON_INDICE_GENERAL"),
			previousBtn : vLabelsNode.attr("BOTON_PAGINA_ANTERIOR"),
			nextBtn : vLabelsNode.attr("BOTON_PAGINA_SIGUIENTE"),
			itemsBtn : vLabelsNode.attr("BOTON_INDICE_ARTICULOS"),
			thumbnailsBtn : vLabelsNode.attr("BOTON_INDICE_MINIATURAS"),
			zoomOutBtn : vLabelsNode.attr("BOTON_PAGINA_ALEJARSE"),
			zoomInBtn : vLabelsNode.attr("BOTON_PAGINA_ACERCARSE"),
			fitWidthBtn : vLabelsNode.attr("BOTON_PAGINA_AJUSTAR_ANCHO"),
			fitFullBtn : vLabelsNode.attr("BOTON_PAGINA_AJUSTAR_COMPLETA"),
			shareBtn : vLabelsNode.attr("BOTON_COMPARTIR"),
			facebookBtn : vLabelsNode.attr("BOTON_FACEBOOK"),
			twitterBtn : vLabelsNode.attr("BOTON_TWITTER"),
			googleBtn : vLabelsNode.attr("BOTON_GOOGLE"),
			emailBtn : vLabelsNode.attr("BOTON_EMAIL"),
			emailSendBtn : vLabelsNode.attr("BOTON_EMAIL_FORMA_ENVIAR"),
			emailSendBtnTit : vLabelsNode.attr("BOTON_EMAIL_FORMA_ENVIAR_TITULO"),
			closeBtn : vLabelsNode.attr("BOTONES_VENTANA_CERRAR"),
			indexWin : vLabelsNode.attr("VENTANA_INDICE_GENERAL"),
			itemsWin : vLabelsNode.attr("VENTANA_INDICE_ARTICULOS"),
			thumbnailsWin : vLabelsNode.attr("VENTANA_INDICE_MINIATURAS"),
			emailWin : vLabelsNode.attr("VENTANA_EMAIL"),
			shareMessageTitle : vLabelsNode.attr("COMPARTIR_MANSAJE_TITULO"),
			html5VideoNotSupported : vLabelsNode.attr("VISUALIZADOR_HTML5_VIDEO_NO_SOPORTADO"),
			html5AudioNotSupported : vLabelsNode.attr("VISUALIZADOR_HTML5_AUDIO_NO_SOPORTADO"),
			emailName : vLabelsNode.attr("EMAIL_FORMA_NOMBRE"),
			emailFrom : vLabelsNode.attr("EMAIL_FORMA_DE"),
			emailTo : vLabelsNode.attr("EMAIL_FORMA_PARA"),
			emailSubject : vLabelsNode.attr("EMAIL_FORMA_TITULO"),
			emailMessage : vLabelsNode.attr("EMAIL_FORMA_MENSAJE"),
			emailOK : vLabelsNode.attr("EMAIL_FORMA_CONFIRMACION"),
			emailError : vLabelsNode.attr("EMAIL_FORMA_ERROR")
		};
		// ITEMS
		var vItemsNode = vRootNode.find("ITEMS");
		init.items = [];
		init.itemsCnt = vItemsNode.children().length;
		vItemsNode.children().each(function(idx){
			var vItemNode = $(this);
			var vItem = {};
			vItem.id = idx;
			vItem.title = vItemNode.attr("TITULO");
			vItem.image = vItemNode.attr("IMAGEN");
			vItem.data = vItemNode.attr("DATA");
			init.items.push(vItem);
		});
		// CALL TO SETUP FUNCTION
		setup();
	}
	
	// APPLICATION SETUP
	function setup(){
		// CHECK SUBSTRINGS IN USERAGENT FOR HIDE SHARE MENU 
		hideShare = hideShare || isInUserAgent(init.config.hideShareMenu);
		// CHECK IF INDEX MENU WOULD BE NEEDED
		var hideIndexParam = parseInt(init.config.showIndex);	
		if((isNaN(hideIndexParam) || hideIndexParam == 0) || init.itemsCnt < 2){$('#header_index').hide();}
		// WINDOWS TITLES
		$('#index_header_title').text(init.labels.indexWin);
		$('#items_header_title').text(init.labels.itemsWin);
		$('#thumbnails_header_title').text(init.labels.thumbnailsWin);
		$('#email_header_title').text(init.labels.emailWin);
		// SETUP CONTENT CONTAINERS
		index = setDragBox($IndexContent, true);	
		items = setDragBox($ItemsContent, true);
		thumbnails = setDragBox($ThumbnailsContent, true);
		viewport = setDragBox($MainContent, false);
		// SETUP BUTTONS
		// INDEX BUTTON
		setButton($('#header_index'), function(){
			_gaq.push(['_trackEvent', 'UI', 'Index']);
			showIndex(true, $Index);
		}, init.labels.indexBtn);
		// MAIN NAV BUTTONS
		setButton($MainPrevious, function(){
			_gaq.push(['_trackEvent', 'UI', 'Previous']);
			pageStep(false);
		}, init.labels.previousBtn);
		setButton($MainNext, function(){
			_gaq.push(['_trackEvent', 'UI', 'Next']);
			pageStep(true);
		}, init.labels.nextBtn);
		// MENU BUTTONS
		setButton($('#footer_menu_items'), function(){
			_gaq.push(['_trackEvent', 'UI', 'Items']);
			showIndex(true, $Items);
		}, init.labels.itemsBtn);
		setButton($('#footer_menu_thumbnails'), function(){
			_gaq.push(['_trackEvent', 'UI', 'Thumbnails']);
			showIndex(true, $Thumbnails);
		}, init.labels.thumbnailsBtn);
		setButton($('#footer_menu_zoom_out'), function(){
			_gaq.push(['_trackEvent', 'UI', 'Zoom out']);
			viewport.scale('out');
		}, init.labels.zoomOutBtn);
		setButton($('#footer_menu_zoom_in'), function(){
			_gaq.push(['_trackEvent', 'UI', 'Zoom in']);
			viewport.scale('in');
		}, init.labels.zoomInBtn);
		setButton($('#footer_menu_fit_width'), function(){
			_gaq.push(['_trackEvent', 'UI', 'Fit width']);
			viewport.scale('width');
		}, init.labels.fitWidthBtn);
		setButton($('#footer_menu_fit_full'), function(){
			_gaq.push(['_trackEvent', 'UI', 'Fit full']);
			viewport.scale('all');
		}, init.labels.fitFullBtn);
		setButton($('#footer_menu_share'), function(){
			_gaq.push(['_trackEvent', 'UI', 'Share']);
			showShare(true);
		}, init.labels.shareBtn);
		// SHARE BUTTONS
		setButton($('#share_menu_facebook'), function(event){
			event.stopPropagation();
			_gaq.push(['_trackEvent', 'UI', 'Facebook']);
			share('facebook');
		}, init.labels.facebookBtn);
		setButton($('#share_menu_twitter'), function(event){
			event.stopPropagation();
			_gaq.push(['_trackEvent', 'UI', 'Twitter']);
			share('twitter');
		}, init.labels.twitterBtn);
		setButton($('#share_menu_google'), function(event){
			event.stopPropagation();
			_gaq.push(['_trackEvent', 'UI', 'Google plus']);
			share('google');
		}, init.labels.googleBtn);
		setButton($('#share_menu_email'), function(event){
			event.stopPropagation();
			_gaq.push(['_trackEvent', 'UI', 'Email']);
			share('email');
		}, init.labels.emailBtn);
		// CLOSE BUTTONS
		setButton($('#index_header_close'), function(){
			showIndex(false);
		}, init.labels.closeBtn);
		setButton($('#items_header_close'), function(){
			showIndex(false);
		}, init.labels.closeBtn);
		setButton($('#thumbnails_header_close'), function(){
			showIndex(false);
		}, init.labels.closeBtn);
		setButton($('#viewer_header_close'), function(){
			showViewer(false);
		}, init.labels.closeBtn);
		setButton($('#email_header_close'), function(){
			showEmail(false);
		}, init.labels.closeBtn);
		// HIDE SHARE (ON IOS STANDALONE, XBOX, OTHERS)
		if(hideShare){
			var shareButton = $('#footer_menu_share');
			var lastSeparator = $('.footer_menu_separator').last();
			var totalWidth = shareButton.width() + lastSeparator.width();
			shareButton.hide();
			lastSeparator.hide();
			$('#footer_menu').css({width:'-=' + totalWidth, 'margin-left': '+=' + ((totalWidth * .5)>>0)});
		}
		// BUILD INDEX WINDOW
		var indices = '';
		for(var i = 0;i<init.itemsCnt;i++){
			indices += '<div class="indices" style="background-image:url('+init.items[i].image+')"><div class="indices_title">' + init.items[i].title + '</div></div>';
		}
		indices += '<div style="clear:both;"></div>';
		index.content(indices);
		$('#index_content_container').children().each(function(idx) {
			if(idx < init.itemsCnt){
				setClick($(this), function(){
					showIndex(false);
					loadMagazine(init.items[idx].id,0);
				});
			}
		});
		// CALL TO CHECK URL VARS (AKA ARGUMENTS) FUNCTION
		checkHash();
	}
	
	// CHECK URL ARGUMENTS FOR MAGAZINE AND/OR PAGE ID
	function checkHash(){
		var hash = locationHash();
		startupArgs.mag = isNaN(hash.mag) ? 0 : Math.max(0, Math.min(init.itemsCnt - 1, hash.mag));
		startupArgs.pag = isNaN(hash.pag) ? 0 : hash.pag;
		if(isiOSStandalone){startupArgs.pag = 0;}
		loadMagazine();
	}
	
	// LOAD MAGAZINE XML DATA
	function loadMagazine(magID, pagID){
		if(typeof magID === 'undefined'){
			loadXML(init.items[startupArgs.mag].data, parseXMLMagazine);
		}else{
			if(magID == startupArgs.mag){return}
			onSplash = true;
			$Share.fadeOut(fadeDuration);
			$Header.fadeOut(fadeDuration);
			$Main.fadeOut(fadeDuration);
			$Footer.fadeOut(fadeDuration, function(){
				viewport.clear();
				$MainPrevious.hide();
				$MainNext.hide();
				$Splash.fadeIn(fadeDuration, function(){
					currentPage = -1;
					startupArgs.mag = Math.max(0, Math.min(init.itemsCnt - 1, magID));
					startupArgs.pag = pagID;
					loadXML(init.items[startupArgs.mag].data, parseXMLMagazine);
				});
			});
		}
	}
	
	// PARSE MAGAZINE XML DATA
	function parseXMLMagazine(xml){
		data.pages = [];
		data.pagesCnt = 0;
		var vRootNode = $(xml).children("PUBLICACION");
		data.title = vRootNode.attr("TITULO");
		data.pages.push(getXMLPage(vRootNode.children("PORTADA")));
		data.pagesCnt++;
		var vArticlesNode = vRootNode.find("ARTICULOS");
		data.articlesCnt = vArticlesNode.children().length;
		data.articles = [];
		var articlesFirstPageID = 1;
		vArticlesNode.children().each(function(){
			var vArticleNode = $(this);
			var vArticle = {};
			vArticle.title = vArticleNode.attr("TITULO");
			vArticle.author = vArticleNode.attr("AUTOR");
			vArticle.firstPageID = articlesFirstPageID;
			var vPagesNode = vArticleNode.find("PAGINAS");
			vArticle.pagesCnt = vPagesNode.children().length;
			vArticle.pages = [];
			vPagesNode.children().each(function(){
				vArticle.pages.push(getXMLPage($(this)));
			});
			articlesFirstPageID += vArticle.pagesCnt;
			data.articles.push(vArticle);
		});
		for (var i = 0; i < data.articlesCnt; i++) {
			for (var j = 0; j < data.articles[i].pagesCnt; j++) {
				data.pages.push(data.articles[i].pages[j]);
				data.pagesCnt++;
			}
		}
		setTimeout(startup, startupDelay);
	}
	
	// PARSE XML PAGES
	function getXMLPage(pageNode){
		var vPage = {};
		vPage.img = pageNode.attr("IMAGEN");
		vPage.thumb = pageNode.attr("IMAGEN").replace(/(.jpg|.jpeg|.png|.gif)/i,init.config.thumbnailsSuffix);		
		var vHotspotsNode = pageNode.children("BOTONES");
		vPage.hotspotsCnt = vHotspotsNode.children().length;
		vPage.hotspots = [];
		vHotspotsNode.children().each(function(){
			var vHotspotNode = $(this);
			var vHotspot = {};
			vHotspot.title = vHotspotNode.attr("TITULO");
			vHotspot.rect = vHotspotNode.attr("RECTANGULO").split(',');
			for(var i = 0; i < 4; i++){
				vHotspot.rect[i] = parseInt(vHotspot.rect[i]);
			}
			vHotspot.type = vHotspotNode.attr("TIPO");
			vHotspot.data = vHotspotNode.text();
			vPage.hotspots.push(vHotspot);
		});
		return vPage;
	}
	
	// APPLICATION STARTUP
	function startup(){
		// MAGAZINE TITLE
		$HeaderTitle.text(data.title);
		// BUILD ITEMS WINDOW
		var itms = '';
		for(var i = 0;i<data.articlesCnt;i++){
			itms += '<div class="item"><div class="item_title">' + data.articles[i].title + '</div><div class="item_autor">' + data.articles[i].author + '</div></div>';
		}
		items.content(itms);
		$('#items_content_container').children().each(function(idx) {
			setClick($(this), function(){
				showIndex(false);
				setPage(data.articles[idx].firstPageID);
			})
		});
		// BUILD THUMBNAILS WINDOW
		var thumbs = '';
		for(var i = 0;i<data.pagesCnt;i++){
			thumbs += '<div class="thumbnail" style="background-image:url('+data.pages[i].thumb+')"><div class="thumbnail_number">' + (i + 1) + '</div></div>';
		}
		thumbs += '<div style="clear:both;"></div>';
		thumbnails.content(thumbs);
		$('#thumbnails_content_container').children().each(function(idx) {
			if(idx < data.pagesCnt){
				setClick($(this), function(){
					showIndex(false);
					setPage(idx);
				})
			}
		});
		// STARTUP
		$Splash.fadeOut(fadeDuration, function(){
			onSplash = false;
			$Splash.hide();
			updateStage();
			$Header.fadeIn(fadeDuration);
			$Main.fadeIn(fadeDuration);
			$Footer.fadeIn(fadeDuration, function(){
				setPage(startupArgs.pag);
			});
		});
	}
	
	// STEPPER FUNCTION CALL FROM MAIN NAVIGATION ARROWS	
	function pageStep(bool) {
		bool ? setPage(currentPage + 1) : setPage(currentPage - 1);
	}
	
	// SET PAGE 
	function setPage(targetPageID){
		if(isLoading || typeof targetPageID === 'undefined' || isNaN(targetPageID) || targetPageID == currentPage || targetPageID < 0 || targetPageID > data.pagesCnt - 1){return;}
		isLoading = true;
		showViewer(false);
		currentPage = Math.max(0, Math.min(data.pagesCnt - 1, targetPageID));
		$HeaderLoader.fadeIn(fadeDuration);
		$MainPageError.hide();
		$MainPrevious.hide();
		$MainNext.hide();
		var loadTime = $.now();		
		var $Image = $(new Image());
		$Image.on('error', function(){
			// LOAD ERROR IMAGE
			$Image.off('error');
			_gaq.push(['_trackEvent', 'Page', 'Error', $Image[0].src]);
			locationHash({mag: startupArgs.mag, pag: currentPage});
			$MainContent.hide();
			currentPage < 1 ? $MainPrevious.hide() : $MainPrevious.show();
			currentPage >= data.pagesCnt - 1 ? $MainNext.hide() : $MainNext.show();
			$HeaderLoader.stop(true);
			$HeaderLoader.fadeOut(fadeDuration);
			$MainPageError.fadeIn(fadeDuration);
			isLoading = false;
			var preloadImgs = [];
			if(currentPage < data.pagesCnt - 1){preloadImgs.push(data.pages[currentPage + 1].img);}
			if(currentPage > 0){preloadImgs.push(data.pages[currentPage - 1].img);}
			preloadImages(preloadImgs);
		})
		$Image.on('load', function(){
			$Image.off('load');
			_gaq.push(['_trackEvent', 'Page', 'Load Time', undefined, $.now() - loadTime]);
			_gaq.push(['_trackEvent', 'Page', 'Loaded', $Image[0].src]);
			locationHash({mag: startupArgs.mag, pag: currentPage});
			viewport.imageMap($Image[0], data.pages[currentPage].hotspots);
			$MainContent.hide();
			currentPage < 1 ? $MainPrevious.hide() : $MainPrevious.show();
			currentPage >= data.pagesCnt - 1 ? $MainNext.hide() : $MainNext.show();
			$HeaderLoader.stop(true);
			$HeaderLoader.fadeOut(fadeDuration);
			$MainContent.fadeIn(fadeDuration, function(){
				isLoading = false;
				var preloadImgs = [];
				if(currentPage < data.pagesCnt - 1){preloadImgs.push(data.pages[currentPage + 1].img);}
				if(currentPage > 0){preloadImgs.push(data.pages[currentPage - 1].img);}
				preloadImages(preloadImgs);
				
			});
		})
		$Image.attr('src',data.pages[currentPage].img);
	}
	
	// ON RESIZE FUNCTION
	function updateStage(){
		if(!onSplash){
			viewport.update();
			index.update();
			items.update();
			thumbnails.update();
		}
		if(mediaPlayer){mediaPlayer.update();}
	}
	
	// SHOW/HIDE INDEX
	function showIndex(bool, $Index){
		if(bool){
			$Block.on(inputEventType.start, function(){
				showIndex(false);
			});
			$Block.fadeIn(fadeDuration);
			$Index.show();
			$Index.css({left:-$Index.width()});
			$Index.animate({left:0},fadeDuration);
			$LastIndex = $Index;
		}else{
			$Block.off(inputEventType.start);
			$Block.fadeOut(fadeDuration);
			$LastIndex.animate({left:-$LastIndex.width()},fadeDuration,function(){
				$LastIndex.hide();	
			});
		}
	}
	
	// SHOW/HIDE (TOGGLE) SHARE
	function showShare(){
		if(!$Share.is(':visible')){
			$Share.show();
			$Share.css({bottom:0});
			$Share.animate({bottom:$Footer.height()},fadeDuration * .5);
		}else{
			$Share.animate({bottom:0},fadeDuration * .5,function(){
				$Share.hide();	
			});
		}
	}
	
	// SHARE FUNCTION
	function share(type){
		showShare();
		var hash = locationHash();
		var shareURL = init.config.webAppAbsoluteURL + '#' + (hash.mag + 1) + '-' + (hash.pag + 1);
		var escapedShareURL = escape(shareURL);
		switch(type){
			case 'facebook':
				window.open('http://www.facebook.com/share.php?u=' + escapedShareURL);
				break;
			case 'twitter':
				window.open('https://twitter.com/share?url=' + escapedShareURL);
				break;
			case 'google':
				window.open('https://plus.google.com/share?url=' + escapedShareURL);
				break;
			case 'email':
				showEmail(true, '', init.labels.shareMessageTitle, shareURL);
				break;
		}
	}
	
	// SHOW/HIDE VIEWER
	function showViewer(bool, hotspot){
		if(bool){
			$ViewerContent.empty();
			switch(hotspot.type){
				case 'PAGINA':
					setPage(parseInt(hotspot.data) - 1);
					return;
				case 'EMAIL':
					if(/\|/.test(hotspot.data)){
						var dat = hotspot.data.split('|');
						showEmail(true, dat[0], dat[1], dat[2], true);
					}else{
						showEmail(true, hotspot.data, '', '', true);
					}
					return;
				case 'ARCHIVO':
					openFile(hotspot.data);
					return;
				case 'URL':
					if(hotspot.data.charAt(0) === forceNewWindowChar){
						var url = hotspot.data.replace(forceNewWindowChar,'');
						window.open(url,'_blank');
						return
					}
					break
				case 'DESCARTES':
					if(hotspot.data.charAt(0) === forceNewWindowChar){
						var url = hotspot.data.replace(forceNewWindowChar,'');
						window.open(url,'_blank');
						return
					}
					break	
			}
			$Block.on(inputEventType.start, function(){
				showViewer(false);
			})
			$ViewerHeaderTitle.text(hotspot.title);
			$ViewerLoader.hide();
			$Block.show();
			$Viewer.show();
			switch(hotspot.type){
				case 'IMAGEN':
					mediaPlayer = setMediaPlayer($ViewerContent, {type:'IMAGE', paths:hotspot.data.split('|')});
					$ViewerLoader.fadeIn(fadeDuration);
					break;
				case 'VIDEO':
					mediaPlayer = setMediaPlayer($ViewerContent, {type:'VIDEO', paths:hotspot.data.split('|')});
					break;
				case 'AUDIO':
					mediaPlayer = setMediaPlayer($ViewerContent, {type:'AUDIO', paths:hotspot.data.split('|')});
					$ViewerLoader.fadeIn(fadeDuration);
					break;
				case 'URL':	
					var frame = '';
					if(isiOS){
						frame = '<div style="position: absolute; width: 100%; height: 100%; overflow: auto;-webkit-overflow-scrolling: touch;">\
								<iframe style="width:100%" src="' + hotspot.data + '" frameborder="0" scrolling="no"></iframe></div>';
					}else{
						frame = '<iframe style="position: absolute; width: 100%; height: 100%; overflow: auto;" src="' + hotspot.data + '" frameborder="0"></iframe>';
					}
					$ViewerContent.append(frame);
					break;
				case 'YOUTUBE':
					$ViewerContent.append('<iframe width="100%" height="100%" src="http://www.youtube.com/embed/' + hotspot.data + '?autoplay=1" frameborder="0" allowfullscreen></iframe>');					
					break;	
				case 'STREET VIEW':
					$ViewerContent.append('<div id="google_street_view" style="width:100%;height:100%;"></div>');
					var $StreetView = $('#google_street_view', $ViewerContent);
					var data = hotspot.data.split('|');
					data[0] = parseFloat(data[0]);
					data[1] = parseFloat(data[1]);
					data[2] = parseInt(data[2]);
					data[3] = parseInt(data[3]);
					data[4] = parseInt(data[4]);
					var latlng = new google.maps.LatLng(data[0], data[1]);
					var pov = {heading: data[2], pitch: data[3], zoom: data[4]};
					var panoramaOptions = {
						position: latlng,
						pov: pov
					};
					var panorama = new google.maps.StreetViewPanorama($StreetView[0], panoramaOptions);
					google.maps.event.trigger(panorama, 'resize');
					break;
				case 'MAPA':
					$ViewerContent.append('<div id="google_maps" style="width:100%;height:100%;"></div>');
					var $Maps = $('#google_maps', $ViewerContent);
					var mapTypes = ['ROADMAP', 'SATELLITE', 'HYBRID', 'TERRAIN'];
					var data = hotspot.data.split('|');
					data[0] = parseFloat(data[0]);
					data[1] = parseFloat(data[1]);
					data[2] = parseInt(data[2]);
					data[3] = mapTypes.indexOf(data[3]) > -1 ? data[3] : mapTypes[0];
					var latlng = new google.maps.LatLng(data[0], data[1]);
					var mapOptions = {  
						center: latlng,  
						zoom: data[2],  
						mapTypeId: google.maps.MapTypeId[data[3]]
					};
					var map = new google.maps.Map($Maps[0], mapOptions);
					var marker = new google.maps.Marker({
						position:latlng,
						map:map,
						title:hotspot.title
					});
					google.maps.event.trigger(map, 'resize');
					map.setZoom(data[2]);
					map.setCenter(latlng);
					break;	
				case 'DESCARTES':
					var frame = '';
					if(/\|/.test(hotspot.data)){
						var dat = hotspot.data.split('|');
						var w = parseInt(dat[1]);
						var h = parseInt(dat[2]);
						var wm = (w * .5) >> 0;
						var hm = (h * .5) >> 0;
						frame = '<iframe style="position: absolute; overflow: hidden; left: 50%; top: 50%; width:' + w + 'px; height:' + h + 'px; margin-left: -' + wm + 'px; margin-top: -' + hm + 'px;" src="' + dat[0] + '" frameborder="0"></iframe>';
					}else{	
						frame = '<iframe style="position: absolute; overflow: auto; width: 100%; height: 100%;" src="' + hotspot.data + '" frameborder="0"></iframe>';
					}
					$ViewerContent.append(frame);
					break;	
				case 'EMBED':
					$ViewerContent.append(hotspot.data);
					break;	
			}
		}else{
			$Block.off(inputEventType.start);
			$('iframe', $ViewerContent).first().removeAttr('src'); // IE 10 IFRAME CLEAR PLUGINS HACK
			$Viewer.hide();
			if(mediaPlayer){
				mediaPlayer.clear();
				mediaPlayer = undefined;
			}
			$ViewerContent.empty();
			$Block.fadeOut(fadeDuration);
		}
	}
	
	// SHOW/HIDE EMAIL FORM
	function showEmail(bool, to, subject, message, blockTo){
		if(bool){
			// IN IOS DEVICES OR '*' IN EMAIL ADRRESS OPEN EMAIL CLIENT
			if((isiOS && !isiOSStandalone) || (to.charAt(0) === forceEmailClientChar)){
				var toParsed = to.replace(forceEmailClientChar,'');
				
				/// ERROR SETTING SUBJECT WEN TO SET IN XML 5/6/2013 /////////////////////////////////////////////////////////////
				
				var mailto = 'mailto:' + (typeof toParsed === 'undefined' ? '' : toParsed) + '?subject=' + (typeof subject === 'undefined' ? '' : subject) + '&body=' + (typeof message === 'undefined' ? '' : message);
				var dummy = $('<div id="email_dummy"></div>');
				$AppContainer.append(dummy)
				dummy.wrap('<a href="'+ mailto + '" />');
				dummy.click();	
				dummy.unwrap()
				dummy.remove();
				return
			}
			// IN OTHER DEVICES OPEN EMAIL FORM
			keyInputEnabled = false;
			$EmailContentContainer.empty();			
			var htmlForm = '<form id="email_form" action="">';
			htmlForm += '<label for="email_form_name" class="email_form_label">' + init.labels.emailName + '</label><br>';
			htmlForm += '<input type="text" id="email_form_name" class="email_form_text_input">';
			htmlForm += '<p><label for="email_form_from" class="email_form_label">' + init.labels.emailFrom + '</label><br>';
			htmlForm += '<input type="text" id="email_form_from" class="email_form_text_input"></p>';
			htmlForm += '<p><label for="email_form_to" class="email_form_label">' + init.labels.emailTo + '</label><br>';
			htmlForm += '<input type="text" id="email_form_to" class="email_form_text_input"></p>';
			htmlForm += '<p><label for="email_form_subject" class="email_form_label">' + init.labels.emailSubject + '</label><br>';
			htmlForm += '<input type="text" id="email_form_subject" class="email_form_text_input"></p>';
			htmlForm += '<p><label for="email_form_message" class="email_form_label">' + init.labels.emailMessage + '</label><br>';
			htmlForm += '<textarea id="email_form_message" class="email_form_text_area"></textarea></p>';
			htmlForm += '</form>';
			htmlForm += '<div id="email_form_send"><div id="email_form_send_title">' + init.labels.emailSendBtnTit + '</div></div>';
			$EmailContentContainer.html(htmlForm);
			var $EmailForm = $('#email_form', $EmailContentContainer);
			var $EmailFormName = $('#email_form_name', $EmailForm);
			var $EmailFormFrom = $('#email_form_from', $EmailForm);
			var $EmailFormTo = $('#email_form_to', $EmailForm);
			var $EmailFormSubject = $('#email_form_subject', $EmailForm);
			var $EmailFormMessage = $('#email_form_message', $EmailForm);
			var $EmailFormSend = $('#email_form_send', $EmailContentContainer);
			var savedEmailFormName = webStorage('email_form_name');
			var savedEmailFormFrom = webStorage('email_form_from');
			if(savedEmailFormName !== null){$EmailFormName.val(savedEmailFormName);}
			if(savedEmailFormFrom !== null){$EmailFormFrom.val(savedEmailFormFrom);}
			if(typeof to !== 'undefined' && to !== ''){$EmailFormTo.val(to)};
			if(typeof subject !== 'undefined' && subject !== ''){$EmailFormSubject.val(subject)};
			if(typeof message !== 'undefined' && message !== ''){$EmailFormMessage.val(message)};
			if(typeof blockTo !== 'undefined'){$EmailFormTo.attr('disabled','disabled')};
			$EmailFormName.focus();
			$EmailFormSend.attr({alt:init.labels.emailSendBtn,title:init.labels.emailSendBtn});
			$EmailFormSend.on(inputEventType.start, function(event){
				event.preventDefault();
				var emailData = {
					name : $.trim($EmailFormName.val()), 
					from : $.trim($EmailFormFrom.val().toLowerCase()),
					to : $.trim($EmailFormTo.val().toLowerCase()), 
					subject : $.trim($EmailFormSubject.val()), 
					message : $.trim($EmailFormMessage.val()), 
					server_mail : init.config.emailSendingServer
				};
				var froms = emailData.from.split(',');
				var tos = emailData.to.split(',');				
				froms.length > 1 ? $EmailFormFrom.val($.trim(froms[0])) : $EmailFormFrom.val(emailData.from)
				tos.length > 1 ? $EmailFormTo.val($.trim(tos[0])) : $EmailFormTo.val(emailData.to)
				var fieldsError = false;
				var fieldsErrorClassName = 'email_form_fields_error'
				if(emailData.name === null || emailData.name === ''){
					$EmailFormName.addClass(fieldsErrorClassName);
					fieldsError = true;
				}else{
					$EmailFormName.removeClass(fieldsErrorClassName);
				}
				if(!verifyEmail(emailData.from)){
					$EmailFormFrom.addClass(fieldsErrorClassName);
					fieldsError = true;
				}else{
					$EmailFormFrom.removeClass(fieldsErrorClassName);
				}
				if(!verifyEmail(emailData.to)){
					$EmailFormTo.addClass(fieldsErrorClassName);
					fieldsError = true;
				}else{
					$EmailFormTo.removeClass(fieldsErrorClassName);
				}
				if(emailData.subject === null || emailData.subject === ''){
					$EmailFormSubject.addClass(fieldsErrorClassName);
					fieldsError = true;
				}else{
					$EmailFormSubject.removeClass(fieldsErrorClassName);
				}
				if(emailData.message === null || emailData.message === ''){
					$EmailFormMessage.addClass(fieldsErrorClassName);
					fieldsError = true;
				}else{
					$EmailFormMessage.removeClass(fieldsErrorClassName);
				}
				if(!fieldsError){
					event.stopPropagation();
					_gaq.push(['_trackEvent', 'UI', 'Send email']);
					$EmailContentContainer.empty();	
					$EmailContentContainer.html('<div id="email_form_response"></div>');
					var $EmailFormResponse =  $('#email_form_response', $EmailContentContainer);
					webStorage('email_form_name', emailData.name);
					webStorage('email_form_from', emailData.from);
					$.ajax({
						type: "POST",
						url: 'dat/php/email.php',
						data: emailData,
						success: function(dat){
							$EmailFormResponse.html(init.labels.emailOK + '<br>' + emailData.to);
						},
						error: function(xhr, status, error){
							$EmailFormResponse.html(init.labels.emailError + '<br>' + '(' + error + ')');
						}
					});
				}
			})
			$Block.on(inputEventType.start, function(){
				showMail(false);
			});
			$Block.show();
			$Email.show();
		}else{
			$Email.hide();
			$Block.off(inputEventType.start);
			$Block.fadeOut(fadeDuration);
			keyInputEnabled = true
		}
	}
	
	function openFile(path){
		if(path.charAt(0) === forceNewWindowChar){
			var url = path.replace(forceNewWindowChar,'');
			window.open(url,'_blank');
		}else{
			$OpenFileDummy.wrap('<a href="' + path + '" />');
			$OpenFileDummy.click();
			$OpenFileDummy.unwrap();
		}
	}
	
	// DRAG BOXES
	function setDragBox($Ele, lt){
		var $Box = $Ele;
		var $Container = $Box.children().first();
		var scrollSpeed = 20;
		var listType = lt;
		var origEvent;
		var offset;
		var position;
		var boxWidth;
		var boxHeight;
		var containerWidth;
		var containerHeight;
		var left;
		var top;
		var currentScale;
		var stepScale = .1;
		var maxScale = 2.0;
		var minScale = .1;
		var origImgWidth = 0;
		var origImgHeight = 0;
		var image;
		var hotspots;
		var $Hotspots;
		var onGestureEnabled = false;
		var imageSize;
		switch(inputEventSupport){
			case 'GESTURE':
				var gestureStart = function(event){
					event.preventDefault();
					onGestureEnabled = true;
					imageSize = image.width;
				};
				var gestureChange = function(event){
					event.preventDefault();
					setScale('gesture', event.originalEvent.scale);
				};
				var gestureEnd = function(event){
					event.preventDefault();
				};
				$Container.on("gesturestart", gestureStart);
				$Container.on("gesturechange", gestureChange);
				$Container.on("gestureend", gestureEnd);
			case 'TOUCH':
				var touchStart = function(event){
					event.preventDefault();
					if(onGestureEnabled){return}
					origEvent = event.originalEvent;
					position = $Container.position();			
					offset = {
						x: origEvent.changedTouches[0].pageX - position.left,
						y: origEvent.changedTouches[0].pageY - position.top
					};
				};
				var touchMove = function(event){
					event.preventDefault();
					if(onGestureEnabled){return;}
					origEvent = event.originalEvent;
					update(origEvent.changedTouches[0].pageX - offset.x, origEvent.changedTouches[0].pageY - offset.y);
				};
				var touchEnd = function(event){
					event.preventDefault();
					if(event.originalEvent.touches.length < 1){onGestureEnabled = false;}
				};
				$Container.on("touchstart", touchStart);
				$Container.on("touchmove", touchMove);
				$Container.on("touchend", touchEnd);
				break
			case 'MOUSE':
				var mouseDown = function(event){
					event.preventDefault();
					position = $Container.position();
					offset = {
						x: 	event.pageX - position.left,
						y:	event.pageY - position.top
					}
					$Document.on("mousemove",mouseMove);
					$Document.on("mouseup",mouseUp);				
				}
				var mouseMove = function(event){
					event.preventDefault();
					update(event.pageX - offset.x, event.pageY - offset.y);
				}
				var mouseUp = function(e){
					$Document.off("mousemove",mouseMove);
					$Document.off("mouseup",mouseUp);
				}
				var mouseWheel = function (event, delta, deltaX, deltaY){
					event.preventDefault();
					position = $Container.position();				
					update(position.left + (deltaX * scrollSpeed), position.top  + (deltaY * scrollSpeed));
				}
				$Container.on("mousedown",mouseDown);
				$Container.on("mouseup",mouseUp);
				$Container.on("mousewheel",mouseWheel);
				break;
		}
		// UPDATE FUNCTION
		function update(x,y){
			if(typeof x === 'undefined'){
				position = $Container.position();
				x = position.left;
				y = position.top;
			}
			boxWidth = $Box.width();
			boxHeight = $Box.height();
			containerWidth = $Container.width();
			containerHeight = $Container.height();
			if(listType){
				top =  y >= 0 ? 0 : y;
				if(containerHeight > boxHeight){
					top = top < (boxHeight - containerHeight) ? boxHeight - containerHeight : top;
				}else{
					top = 0;
				}
			}else{
				left = x >= 0 ? 0 : x;
				left = left < boxWidth - containerWidth ? boxWidth - containerWidth : left;
				left = containerWidth < boxWidth ? ((boxWidth - containerWidth) * .5) >> 0 : left;
				top =  y >= 0 ? 0 : y;
				top = top < boxHeight - containerHeight ? boxHeight - containerHeight : top;
				top = containerHeight < boxHeight ? ((boxHeight - containerHeight) * .5) >> 0 : top; 
			}
			$Container.css({left: left, top: top});
		}
		// SET CONTENT FUNCTION
		function setContent(content){
			$Container.empty();
			$Container.append(content);
		}
		// SET IMAGE MAP FUNCTION
		function setImageMap(img, hss){
			$Container.empty();
			image = img;
			image.style.position = 'absolute';
			origImgWidth = image.width;
			origImgHeight = image.height;
			$Container.append(image);
			$Container.css({width:image.width, height:image.height});
			hotspots = hss;
			var hsString = '';
			for(var i = 0; i < hotspots.length; i++){
				hsString += '<div class="hotspot" title="' +  hotspots[i].title + '"></div>';
			}
			$Container.append(hsString);
			$Hotspots = $('div', $Container);
			$Hotspots.each(function(idx){
				setClick($(this), function(){
					showViewer(true, hotspots[idx]);
				});			
			});
			typeof currentScale === 'undefined' ? setScale('all') : setScale('previous');
			update(0,0);
		}
		// SET SCALE FUNCTION
		function setScale(type, scale){
			switch(type){
				case 'gesture':
					currentScale = (imageSize * scale) / origImgWidth;
					break;
				case 'in':
					currentScale = (image.width/origImgWidth) + stepScale;
					break;
				case 'out':
					currentScale = (image.width/origImgWidth) - stepScale;
					break;
				case 'width':
				case 'all':				
					var xScale = $Box.width() / origImgWidth;
					var yScale = $Box.height() / origImgHeight;										
					currentScale = type === 'width' ? xScale : (xScale < yScale ? xScale : yScale);
					break;
				case 'previous':
					break;
			}
			currentScale = currentScale > maxScale ? maxScale : currentScale;
			currentScale = currentScale < minScale ? minScale : currentScale;
			image.width =  (origImgWidth * currentScale) >> 0;
			image.height = (origImgHeight * currentScale) >> 0;
			$Container.css({width:image.width, height:image.height});
			$Hotspots.each(function(idx){
				var $This = $(this);
				var hs = hotspots[idx];
				$This.css({left:Math.round(hs.rect[0] * currentScale), top:Math.round(hs.rect[1] * currentScale), width:Math.round(hs.rect[2] * currentScale), height:Math.round(hs.rect[3] * currentScale)});
			})
			update();
		}
		// SET SCROLL FUNCTION
		function setScroll(bool){ 
			position = $Container.position();				
			update(position.left, position.top  + (3 * (bool ? 1 : -1) * scrollSpeed));
		}
		// CLEAR FUNCTION
		function clear(){
			$Container.empty();
			currentScale = undefined;
			$Container.css({width:'', height:''});
		}
		// OBJECT RETURN (REVEALING MODULE PATTERN)
		return {
			update: function(){
				update();
			},
			content: function(content){
				setContent(content);
			},
			imageMap: function(img, hss){
				setImageMap(img, hss);
			},
			position: function(x,y){
				update(x,y);
			},			
			scale: function(type){
				setScale(type);
			},
			scroll: function(bool){
				setScroll(bool)
			},
			clear: function(){
				clear();
			}
		}
	}
	
	// INSTALL JQUERY MOUSE WHEEL EVENT
	function installMouseWheelEvent(){
		var types = ['DOMMouseScroll', 'mousewheel'];
		if($.event.fixHooks){
			for(var i = types.length; i;) {
				$.event.fixHooks[ types[--i]] = $.event.mouseHooks;
			}
		}
		$.event.special.mousewheel = {
			setup: function(){
				if(this.addEventListener){
					for(var i=types.length; i;){
						this.addEventListener(types[--i], handler, false);
					}
				}else{
					this.onmousewheel = handler;
				}
			},
			teardown: function(){
				if (this.removeEventListener){
					for(var i = types.length; i;){
						this.removeEventListener(types[--i], handler, false);
					}
				} else {
					this.onmousewheel = null;
				}
			}
		};
		$.fn.extend({
			mousewheel: function(fn){
				return fn ? this.bind("mousewheel", fn) : this.trigger("mousewheel");
			},
			unmousewheel: function(fn){
				return this.unbind("mousewheel", fn);
			}
		});
		function handler(event){
			var orgEvent = event || window.event; 
			var args = [].slice.call( arguments, 1);
			var delta = 0;
			var returnValue = true;
			var deltaX = 0;
			var deltaY = 0;
			event = $.event.fix(orgEvent);
			event.type = "mousewheel";
			if(orgEvent.wheelDelta){
				delta = orgEvent.wheelDelta / 120;
			}
			if(orgEvent.detail){
				delta = -orgEvent.detail / 3;
			}
			deltaY = delta;
			if(orgEvent.axis !== undefined && orgEvent.axis === orgEvent.HORIZONTAL_AXIS){
				deltaY = 0;
				deltaX = -1 * delta;
			}
			if(orgEvent.wheelDeltaY !== undefined ){
				deltaY = orgEvent.wheelDeltaY / 120;
			}
			if(orgEvent.wheelDeltaX !== undefined ){
				deltaX = -1 * orgEvent.wheelDeltaX / 120;
			}
			args.unshift(event, delta, deltaX, deltaY);
			return ($.event.dispatch || $.event.handle).apply(this, args);
		}
	}
	
	// MADIA PLAYER
	function setMediaPlayer($Ele, par){
		var $Container = $Ele;
		var params = par;
		var $Image;
		var origImageWidth;
		var origImageHeight;
		var allowUpdate = false;
		var imagePath = getPathFromExtension(params.paths, '.jpg') || getPathFromExtension(params.paths, '.png') || getPathFromExtension(params.paths, '.gif');
		$Container.empty();
		switch(params.type){
			case 'IMAGE':
				if(imagePath){loadImage(imagePath);}
				break;
			case 'AUDIO':
				if(imagePath){loadImage(imagePath);}
				var mp3 = getPathFromExtension(params.paths, '.mp3');
				var ogg = getPathFromExtension(params.paths, '.ogg');
				var oga = getPathFromExtension(params.paths, '.oga');
				var wav = getPathFromExtension(params.paths, '.wav');
				var element = '<audio id="media" style="position:absolute;width:100%;border:0;bottom:0px;" controls autoplay>';
				if(mp3){element += '<source src="' + mp3 + '" type="audio/mpeg">';}
				if(ogg){element += '<source src="' + ogg + '" type="audio/ogg">';}
				if(oga){element += '<source src="' + oga + '" type="audio/ogg">';}
				if(wav){element += '<source src="' + wav + '" type="audio/wav">';}
				element += '<div class="no_html5_audio_video_support">' + init.labels.html5AudioNotSupported + '</div></audio>';
				$Container.html(element);
				break;
			case 'VIDEO':
				var mp4 = getPathFromExtension(params.paths, '.mp4');
				var webm = getPathFromExtension(params.paths, '.webm');
				var ogv = getPathFromExtension(params.paths, '.ogv');
				var element = '<video id="media" style="width:100%;height:100%;border:0;" controls autoplay' + (imagePath ? ' poster="' + imagePath + '">' : '>');
				if(mp4){element += '<source src="' + mp4 + '" type="video/mp4">';}
				if(webm){element += '<source src="' + webm + '" type="video/webm">';}
				if(ogv){element += '<source src="' + ogv + '" type="video/ogg">';}				
				element += '<div class="no_html5_audio_video_support">' + init.labels.html5VideoNotSupported + '</div></video>';
				$Container.html(element);
				break;
		}
		// GET PATH FROM EXTENSION FUNCTION
		function getPathFromExtension(array, ext){	
			var re = new RegExp('\\' + ext, 'i');
			for(var i = 0; i<array.length; i++){
				if(re.test(array[i])){
					return array[i];
				}
			}
		}	
		// LOAD IMAGE FUNCTION
		function loadImage(path){
			$Image = $(new Image());
			$Image.on('load', function(){
				$Image.off('load');
				origImageWidth = $Image[0].width;
				origImageHeight = $Image[0].height;						
				$Image.css({position:'absolute', border:0})
				$Image.hide();
				$Container.prepend($Image);
				allowUpdate = true;
				update();
				$Image.fadeIn(fadeDuration);
				$ViewerLoader.stop(true);
				$ViewerLoader.fadeOut(fadeDuration);
			})
			$Image.attr('src',path);
		}
		// UPDATE FUNCTION
		function update(){
			if(allowUpdate){
				var contWidth = $Container.width();
				var contHeight = $Container.height();
				var xScale = contWidth / origImageWidth;
				var yScale = contHeight / origImageHeight;									
				var scale = xScale < yScale ? xScale : yScale;
				var targetWidth = scale * origImageWidth;
				var targetHeight = scale * origImageHeight;
				if(targetWidth > origImageWidth || targetHeight > origImageHeight){
					targetWidth =  origImageWidth;
					targetHeight = origImageHeight;
				}
				var x = ((contWidth - targetWidth) * .5) >> 0;
				var y = ((contHeight - targetHeight) * .5) >> 0;
				$Image.css({left:x,top:y,width:Math.round(targetWidth),height:Math.round(targetHeight)})
			}
		}
		// CLEAR FUNCTION
		function clear(){
			var media = $('#media', $Container)[0];
			if(typeof media !== 'undefined'){
				media.pause();
				media.parentNode.removeChild(media);
				media = 0;
			}
			$Container.empty();
		}
		// OBJECT RETURN (REVEALING MODULE PATTERN)
		return {
			update : function() { 
				update();
			},
			clear : function(){
				clear();
			}
		};
	}
	
	//////////////////////////////////////////////////////////////////////
	///////////////////////////// TOOLBOX ////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	
	// SETING BUTTONS ABSTRACT FUNCTION 
	function setButton($El, fnt, tit){
		$El.on(inputEventType.start, fnt);
		$El.attr({alt:tit,title:tit});
	}
	
	// PRESS & DRAG BEHAVIOR CONTROL 
	function setClick($Ele, cb){
		var $Element = $Ele;
		var callback = cb;
		var isTouch = inputEventType.type == 'touch' 
		var clickDelay = 1000;
		var clickDistance = 10;
		var startTime;
		var x;
		var y;
		$Element.on(inputEventType.start, function(event){
			event.preventDefault();
			startTime = $.now();
			if(isTouch){
				x = event.originalEvent.changedTouches[0].pageX;
				y = event.originalEvent.changedTouches[0].pageY;
			}else{
				x = event.pageX;
				y = event.pageY;
			}
		})
		$Element.on(inputEventType.end, function(event){
			event.preventDefault();
			if(isTouch){
				var lastX = event.originalEvent.changedTouches[0].pageX;
				var lastY = event.originalEvent.changedTouches[0].pageY;
			}else{
				var lastX = event.pageX;
				var lastY = event.pageY;
			}
			if($.now() - startTime <= clickDelay && (clickDistance * clickDistance) >= ((lastX - x) * (lastX - x)) + ((lastY - y) * (lastY - y))){
				callback();
			}
		})
	}
	
	// BROWSER HISTORY NAVIGATION 
	// ON HASH CHANGE
	function hashChange(){
		var hash = locationHash();
		if(isNaN(hash.mag) || isNaN(hash.pag)){return;};
		if(hash.mag !== startupArgs.mag){
			loadMagazine(hash.mag, hash.pag)
		}else{
			setPage(hash.pag);
		}
	}
	
	// GET & SET HASH
	function locationHash(hash){
		if(typeof hash === 'undefined'){
			var rawHash = window.location.hash.substring(1).split("-")
			return {mag: parseInt(rawHash[0]) - 1, pag: parseInt(rawHash[1]) - 1}
		}else{
			window.location.hash = (hash.mag + 1) + '-' + (hash.pag + 1);
		}
	}	
	
	// GENERIC ASYNCHRONOUS XML LOAD
	function loadXML(path, callback){
		$.ajax({
			type: "GET",
			url: path + '?v=1',
			dataType: "xml",
			success: callback,
			error: function(xhr, status, error){alert(path + ' (' + error + ')')}
		});	
	}
	
	// GENERIC FUNCTION FOR PRELOAD IMAGES
	function preloadImages(images) {
		var preload = [];
		var cnt = images.length;
		for(var i = 0; i < cnt; i++) { 
			preload[i] = new Image();
			preload[i].src = images[i];
		}
	}
	
	// SHOW/HIDE TOUCH IMAGE
	function showTouch(bool, x, y){
		if(bool){
			$Touch.css({left:x,top:y});
			$Touch.show();
		}else{
			$Touch.hide();
		}
	}
	
	// GENERIC REGULAR EXPRESSION FOR "VALIDATE" EMAILS
	function verifyEmail(mail){
		var regEx = new RegExp("[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?");
		return regEx.test(mail)
	}
	
	// GENERIC REGULAR EXPRESSION FOR FIND SUBSTRINGS IN USERAGENT
	function isInUserAgent(userAgents){
		var regEx = new RegExp("(" + userAgents + ")", 'i');
		return regEx.test(navigator.userAgent)
	}
	
	// GENERIC WEB STORAGE
	function webStorage(key, value){
		if(!localStorage){return null};
		if(typeof value === 'undefined'){
			return localStorage.getItem(key)
		}else{
			localStorage.setItem(key, value)
		}
	}
	
	// END OF FILE
});